program mod_sum2;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Windows,
  SysUtils;

type
  TUInt128 = record
    case Integer of
      0: (Lo, Hi: UInt64);
      1: (LoLo, LoHi, HiLo, HiHi: Cardinal);
      2: (Bytes: array [0 .. 15] of Byte);
  end;

  procedure Add128(var Sum, Addend: TUInt128);
  begin
    if Sum.Lo >= UInt64($FFFFFFFFFFFFFFFF) - Addend.Lo then
      Inc(Sum.Hi);
    Sum.Lo := Sum.Lo + Addend.Lo;
    Sum.Hi := Sum.Hi + Addend.Hi;
  end;

  procedure Sub128(var Sum, Addend: TUInt128);
  begin
    if Sum.Lo < Addend.Lo then
      Dec(Sum.Hi);
    Sum.Lo := Sum.Lo - Addend.Lo;
    Sum.Hi := Sum.Hi - Addend.Hi;
  end;

  //Sq = Sqr(Value.Lo)
  procedure Sqr128(var Sq, Value: TUInt128);
  var
    ad: TUInt128;
  begin
    Sq.Hi := UInt64(Value.LoHi) * Value.LoHi;
    Sq.Lo := UInt64(Value.LoLo) * Value.LoLo;
    ad.Lo := UInt64(Value.LoHi) * Value.LoLo;
    ad.Hi := ad.LoHi;
    ad.Lo := ad.Lo shl 32;
    Add128(Sq, ad);
    Add128(Sq, ad);
  end;

  function SumOfMods128(N: Int64): TUInt128;
  var
    Minus, Divider: UInt64;
    Even: Boolean;
    V, Sq: TUInt128;
  begin
    Result.Lo := 0;
    Result.Hi := 0;
    Minus := 1;
    Divider := 2;
    Even := True;
    V.Hi := 0;
    while Minus < N do begin
      V.Lo := (N - Minus) div Divider;
      Sqr128(Sq, V);
      if Even then
        Add128(Result, Sq)
      else
        Sub128(Result, Sq);
      Minus := Minus + Divider;
      Divider := Divider + 1;
      Even := not Even;
    end;
  end;

var
  N: Int64;
  Res128: TUInt128;
  Start: DWORD;
begin
  Start := GetTickCount;
  N := 1000000000000;
  Res128 := SumOfMods128(N);
  Writeln('Result: 0x', IntToHex(Res128.Hi, 16), IntToHex(Res128.Lo, 16));
  Writeln('Time elapsed: ', GetTickCount - Start);
  Readln;
end.
