program mod_sum;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Windows,
  SysUtils;

type
  UInt128 = record
    Lo, Hi: UInt64;
  end;

var
  VeryBigInteger: UInt128;

procedure Adder(X: Int64);
var
  Tmp: UInt128;
begin
  Tmp := VeryBigInteger;
  Inc(VeryBigInteger.Lo, X);
  if (VeryBigInteger.Lo < Tmp.Lo) or (VeryBigInteger.Lo < X) then
    Inc(VeryBigInteger.Hi);
end;

function summ(a1, an: UInt64; n: Integer): UInt64;
begin
  //      ,    
  if n = 1 then
    Result := a1
  else
    //       
    Result := (n * (a1 + an)) shr 1;
end;

procedure Calc(Limit: Int64);
const
  MaxProgressionSize = 900000;
var
  nCount,             //    
  pMinLimit,          //   
  pMaxLimit,          //   
  pIncrement,         //    
  pCount,             //   
  pSumm,              //   
  TmpMaxLimit: Int64; //    
  Start: DWORD;
begin
  //  
  Start := GetTickCount;
  ZeroMemory(@VeryBigInteger, SizeOf(UInt128));
  nCount := Limit;
  pIncrement := 1;
  pMinLimit := 0;
  pMaxLimit := Limit div (pIncrement + 1) -
    (pIncrement - (Limit mod (pIncrement + 1)));
  while nCount > 0 do
  begin
    //    
    pCount := 1 + (pMaxLimit - pMinLimit) div pIncrement;
    //       - ,
    //           Int64
    //     
    while pCount > MaxProgressionSize do
    begin
      //     
      TmpMaxLimit := pMinLimit + (pIncrement * (MaxProgressionSize - 1));
      //   
      pSumm := summ(pMinLimit, TmpMaxLimit, MaxProgressionSize);
      // 
      Adder(pSumm);
      //  -   
      Dec(pCount, MaxProgressionSize);
      //  -   
      Dec(nCount, MaxProgressionSize);
      //    
      pMinLimit := TmpMaxLimit + pIncrement;
    end;

    //   
    pSumm := summ(pMinLimit, pMaxLimit, pCount);
    // 
    Adder(pSumm);
    //  -   
    Dec(nCount, pCount);
    //    - 
    if nCount = 0 then
      Break;
    //     
    pMinLimit := Limit mod nCount;
    //     
    Inc(pIncrement);
    pMaxLimit := Limit div (pIncrement + 1) -
      (pIncrement - (Limit mod (pIncrement + 1)));
    // ,   ,   
    if pMaxLimit <= 0 then
      //       ,
      //  pCount       (  )
      pMaxLimit := 0;
  end;
  //    
  Writeln('Result: 0x', IntToHex(VeryBigInteger.Hi, 16), IntToHex(VeryBigInteger.Lo, 16));
  Writeln('Time elapsed: ', GetTickCount - Start);
end;

var
  N: int64;
begin
  try
    repeat
      Writeln('Input N or zero (0) for exit: ');
      Readln(N);
      if N > 1000000000000 then
      begin
        Writeln('Too much value, repeat input.');
        Continue;
      end;
      if N < 0 then
      begin
        Writeln('Wrong value, repeat input.');
        Continue;
      end;
      if N <> 0 then
      begin
        Writeln('calculate...');
        Calc(N);
      end;
    until N = 0;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
