program mod_sum3;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  Windows,
  SysUtils;

type
  TSum= array[0..3] of int64;

procedure Zero128(var sum: TSum);
begin;
  sum[0]:=0;
  sum[1]:=0;
  sum[2]:=0;
  sum[3]:=0;
end;

procedure Add128Progression(var sum: TSum; val, count: int64); //sum:=sum + val * count shr 1;
var
  t: int64;
begin;
  if val and 1=0 then val:=val shr 1 else count:=count shr 1;
  t:=int64(Int64Rec(val).Lo) * Int64Rec(count).Lo;
  sum[0]:=sum[0] + Int64Rec(t).Lo;
  sum[1]:=sum[1] + Int64Rec(t).Hi;
  t:=int64(Int64Rec(val).Lo) * Int64Rec(count).Hi;
  sum[1]:=sum[1] + Int64Rec(t).Lo;
  sum[2]:=sum[2] + Int64Rec(t).Hi;
  t:=int64(Int64Rec(val).Hi) * Int64Rec(count).Lo;
  sum[1]:=sum[1] + Int64Rec(t).Lo;
  sum[2]:=sum[2] + Int64Rec(t).Hi;
  t:=int64(Int64Rec(val).Hi) * Int64Rec(count).Hi;
  sum[2]:=sum[2] + Int64Rec(t).Lo;
  sum[3]:=sum[3] + Int64Rec(t).Hi;
end;

procedure Norm128(var sum: TSum);
begin;
  sum[1]:=sum[1] + Int64Rec(sum[0]).Hi; Int64Rec(sum[0]).Hi:=0;
  sum[2]:=sum[2] + Int64Rec(sum[1]).Hi; Int64Rec(sum[1]).Hi:=0;
  sum[3]:=sum[3] + Int64Rec(sum[2]).Hi; Int64Rec(sum[2]).Hi:=0;
                                        Int64Rec(sum[3]).Hi:=0;
end;

procedure Add128(var sum: TSum; val: int64); //sum:=sum + val;
begin;
  sum[0]:=sum[0] + Int64Rec(val).Lo;
  sum[1]:=sum[1] + Int64Rec(val).Hi;
end;

procedure Add128Norm(var sum: TSum; val: int64); //sum:=norm(sum + val);
begin;
  Add128(sum, val);
  Norm128(sum);
end;

procedure Not128Norm(var sum: TSum); //sum:=norm(not sum);
begin;
  Norm128(sum);
  Int64Rec(sum[0]).Lo:=not Int64Rec(sum[0]).Lo;
  Int64Rec(sum[1]).Lo:=not Int64Rec(sum[1]).Lo;
  Int64Rec(sum[2]).Lo:=not Int64Rec(sum[2]).Lo;
  Int64Rec(sum[3]).Lo:=not Int64Rec(sum[3]).Lo;
end;

procedure Neg128(var sum: TSum); //sum:=-sum;
begin;
  Not128Norm(sum);
  Add128(sum, 1);
end;

procedure Sum128(var sum: TSum; n: int64);
var
  m, c: cardinal;
  i, t: int64;
begin;
  Zero128(sum); t:=0;
  c:=trunc(sqrt(n+0.0));
  m:=c+1;
  dec(c, ord(int64(c)*c=n));
  while c>1 do begin;
    i:=n div c;
    t:=t + (cardinal(n)-cardinal(i)*c);
    Add128Progression(sum, i+m, i-m+1);
    dec(c);
    end;
  Neg128(sum);
  Add128Progression(sum, n-m, n-m+1);
  Add128Norm(sum,t);
  end;

var
  m, n: int64;
  sum: TSum;
  t: DWORD;
begin
  N := 1000000000000;
  t := GetTickCount;
  Sum128(sum, n);
  t:=GetTickCount-t;
  Writeln(Format('%dms   %.8x %.8x %.8x %.8x',[t, sum[3], sum[2], sum[1], sum[0]]));
  Readln;
end.
